---
title: "Tutoriel git <small><br> <hr> [introduction](index.html) | [installation](installation.html) | [dépôt local](depot_local.html) | [dépôt distant](depot_distant.html) | [branches](branches.html) | [forks](forks.html) <hr> </small>"
output:
    toc: true
---

* * * * *

# Branches 

Lorsque l'on travaille sur un dépôt, on réalise des commits successifs. Git
permet également, à partir d'un commit donné, de réaliser plusieurs branches de
commits en parallèle.  Ceci permet de faire une série de modifications sans
risquer de perturber la branche principale du projet, utilisée par tout le
monde.  Une branche peut ensuite être fusionnée dans une autre, par exemple
dans la branche principale, pour y intégrer ses modifications une fois
abouties.  Si les modifications n'ont pas abouties, la branche peut être
abandonnée ou même supprimée.

L'utilisation des branches est très naturelle avec git et permet d'organiser le
déroulement du projet. Souvent, on utilise une branche master qui "doit
toujours fonctionner"; pour chaque fonctionnalité à ajouter, on dérive une
nouvelle branche que l'on fusionne ensuite dans le master une fois la
fonctionnalité réalisée (ou partiellement réalisée) et testée.

![](branches_01.svg)

## Afficher les branches 
![](branches_01.png)

git log --graph --all --oneline --decorate

## Créer une nouvelle branche locale
![](branches_02.png)

## Changer de branche
![](branches_03.png)

![](branches_05.png)

## Fusionner des branches

![](branches_06.png)
![](branches_08.png)
![](branches_09.png)
![](branches_10.png)

## Envoyer une branche sur un dépôt distant
![](branches_11.png)
![](branches_12.png)

## Afficher les branches distantes
![](branches_15.png)

## Terminer une branche locale
![](branches_13.png)

## Terminer une branche distante
![](branches_16.png)

## Supprimer un commit déjà pushé (DANGER !!!)
git reset --hard e6c8e8e
git push origin HEAD:master -f
git reset --hard e6c8e8e

![](branches_18.png)


TODO : supprimer

![](branches_17.png)
![](branches_21.png)

## Résumé et méthode de travail

Résumé des commandes git précédentes :

---|---|
`git ` | |

Quelques conseils de méthode de travail :

- TODO


## Exercice

TODO

* * * * *

[Retour au début de la page](#header)

[Retour à la page d'accueil](../../index.html)

Dernière mise à jour : 2016-03-05

